/* 	============================================================================
    Main Header File
   	========================================================================= */
#include <xc.h>
#include <stdint.h>

/* 	============================================================================
    Section: Macro Declarations and defines
   	========================================================================= */
#define _XTAL_FREQ          8000000

/* 	============================================================================
	Section: Global variables  
  	========================================================================= */
// Even if variables are 'bit' type, we use uint8_t (char) to make them easy 
// to watch while debugging in Proteus .

uint8_t Var_SW_S2, Var_SW_S2_old = 0; 
uint8_t Var_SW_S1, Var_SW_S1_old = 0; 
uint8_t Var_LED8; 
uint8_t Var_LED7; 

//Flag that will be set only when there is new information to print on the LCD
uint8_t Var_LCD_Flag;	

uint8_t Var_INT0_flag; // Software flag to be set when INT0

/* 	============================================================================
	Section: Function prototypes
   	========================================================================= */
void truth_table (void);
void write_outputs (void);
void read_inputs(void);  
void init_system(void);
